//---- Start

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 Red
#property indicator_color2 Red

extern bool Show_Alert = true;
extern bool Display_Zebra7 = true;
extern bool Display_Zebra8 = true;
extern bool Display_Zebra9 = true;
extern bool Display_Zebra10 = true;
extern bool Display_Zebra11 = true;


//---- buffers
double upArrow[];
double downArrow[];
string PatternText[50];


//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init() {

//---- indicators
   
   SetIndexStyle(0,DRAW_ARROW, EMPTY);
   SetIndexArrow(0,72);
   SetIndexBuffer(0, downArrow);
      
   SetIndexStyle(1,DRAW_ARROW, EMPTY);
   SetIndexArrow(1,71);
   SetIndexBuffer(1, upArrow);
      
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit() {
   ObjectsDeleteAll(0, OBJ_TEXT);
   return(0);
}
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start(){

   double Range, AvgRange;
   int counter, setalert;
   static datetime prevtime = 0;
   int shift;
   int shift1;
   int shift2;
   int shift3;
   int shift4; 
   int shift5;
   int shift6;
   int shift7;
   int shift8;
   int shift9;
   int shift10;
   int shift11;
   string pattern, period;
   int setPattern = 0;
   int alert = 0;
   double O, O1, O2, O3, O4, O5, O6, O7, O8, O9, O10, C, C1, C2, C3, C4, C5, C6, C7, C8, C9, C10; 

   
     
   if(prevtime == Time[0]) {
      return(0);
   }
   prevtime = Time[0];
   
   switch (Period()) {
      case 1:
         period = "M1";
         break;
      case 5:
         period = "M5";
         break;
      case 15:
         period = "M15";
         break;
      case 30:
         period = "M30";
         break;      
      case 60:
         period = "H1";
         break;
      case 240:
         period = "H4";
         break;
      case 1440:
         period = "D1";
         break;
      case 10080:
         period = "W1";
         break;
      case 43200:
         period = "MN";
         break;
   }
   
   for (int j = 0; j < Bars; j++) { 
         PatternText[j] = "pattern-" + j;
   }
   
   for (shift = 0; shift < Bars; shift++) {
      
      setalert = 0;
      counter=shift;
      Range=0;
      AvgRange=0;
      for (counter=shift ;counter<=shift+9;counter++) {
         AvgRange=AvgRange+MathAbs(High[counter]-Low[counter]);
      }
      Range=AvgRange/10;
      shift1 = shift + 1;
      shift2 = shift + 2;
      shift3 = shift + 3;
      shift4 = shift + 4;
      shift5 = shift + 5;
      shift6 = shift + 6;
      shift7 = shift + 7;
      shift8 = shift + 8;
      shift9 = shift + 9;
      shift10 = shift + 10;
      shift11 = shift + 11;
     
      
      O  = Open[shift1];
      O1 = Open[shift2];
      O2 = Open[shift3];
      O3 = Open[shift4];
      O4 = Open[shift5];
      O5 = Open[shift6];
      O6 = Open[shift7];
      O7 = Open[shift8];
      O8 = Open[shift9];
      O9 = Open[shift10];
      O10= Open[shift11];
         
      C  = Close[shift1];
      C1 = Close[shift2];
      C2 = Close[shift3];
      C3 = Close[shift4];
      C4 = Close[shift5];
      C5 = Close[shift6];
      C6 = Close[shift7];
      C7 = Close[shift8];
      C8 = Close[shift9];
      C9 = Close[shift10];
      C10= Close[shift11];
         
         
         
      //Zebra pattern   
           
          // Zebra 7 pattern
      if (((O<=C)&&(O1>=C1)&&(O2<=C2)&&(O3>=C3)&&(O4<=C4)&&(O5>=C5)&&(O6<=C6)) || ((O>=C)&&(O1<=C1)&&(O2>=C2)&&(O3<=C3)&&(O4>=C4)&&(O5<=C5)&&(O6>=C6)))
      
      {
         if (Display_Zebra7 == true) {   
            ObjectCreate(PatternText[shift], OBJ_TEXT, 0, Time[shift1], Low[shift1] - Range*1.5);
            ObjectSetText(PatternText[shift], "Zebra 7", 9, "Times New Roman", Red);
            upArrow[shift1] = Low[shift1] - Range*0.5;
         }
         if (setalert == 0 && Show_Alert == true) {
            pattern="Zebra 7";
            setalert = 1;
         }
      }
      
          // Zebra 8 pattern
      if (((O<=C)&&(O1>=C1)&&(O2<=C2)&&(O3>=C3)&&(O4<=C4)&&(O5>=C5)&&(O6<=C6)&&(O7>=C7)) || ((O>=C)&&(O1<=C1)&&(O2>=C2)&&(O3<=C3)&&(O4>=C4)&&(O5<=C5)&&(O6>=C6)&&(O7<=C7)))
      
      {
         if (Display_Zebra8 == true) {   
            ObjectCreate(PatternText[shift], OBJ_TEXT, 0, Time[shift1], Low[shift1] - Range*1.5);
            ObjectSetText(PatternText[shift], "Zebra 8", 9, "Times New Roman", Red);
            upArrow[shift1] = Low[shift1] - Range*0.5;
         }
         if (setalert == 0 && Show_Alert == true) {
            pattern="Zebra 8";
            setalert = 1;
         }
      }
            
          // Zebra 9 pattern
      if (((O<=C)&&(O1>=C1)&&(O2<=C2)&&(O3>=C3)&&(O4<=C4)&&(O5>=C5)&&(O6<=C6)&&(O7>=C7)&&(O8<=C8)) || ((O>=C)&&(O1<=C1)&&(O2>=C2)&&(O3<=C3)&&(O4>=C4)&&(O5<=C5)&&(O6>=C6)&&(O7<=C7)&&(O8>=C8)))
      
      {
         if (Display_Zebra9 == true) {   
            ObjectCreate(PatternText[shift], OBJ_TEXT, 0, Time[shift1], Low[shift1] - Range*1.5);
            ObjectSetText(PatternText[shift], "Zebra 9", 9, "Times New Roman", Red);
            upArrow[shift1] = Low[shift1] - Range*0.5;
         }
         if (setalert == 0 && Show_Alert == true) {
            pattern="Zebra 9";
            setalert = 1;
         }
      }
      
          // Zebra 10 pattern
      if (((O<=C)&&(O1>=C1)&&(O2<=C2)&&(O3>=C3)&&(O4<=C4)&&(O5>=C5)&&(O6<=C6)&&(O7>=C7)&&(O8<=C8)&&(O9>=C9)) || ((O>=C)&&(O1<=C1)&&(O2>=C2)&&(O3<=C3)&&(O4>=C4)&&(O5<=C5)&&(O6>=C6)&&(O7<=C7)&&(O8>=C8)&&(O9<=C9)))
      
      {
         if (Display_Zebra10 == true) {   
            ObjectCreate(PatternText[shift], OBJ_TEXT, 0, Time[shift1], Low[shift1] - Range*1.5);
            ObjectSetText(PatternText[shift], "Zebra 10", 9, "Times New Roman", Red);
            upArrow[shift1] = Low[shift1] - Range*0.5;
         }
         if (setalert == 0 && Show_Alert == true) {
            pattern="Zebra 10";
            setalert = 1;
         }
      }
      
          // Zebra 11 pattern
      if (((O<=C)&&(O1>=C1)&&(O2<=C2)&&(O3>=C3)&&(O4<=C4)&&(O5>=C5)&&(O6<=C6)&&(O7>=C7)&&(O8<=C8)&&(O9>=C9)&&(O10<=C10)) || ((O>=C)&&(O1<=C1)&&(O2>=C2)&&(O3<=C3)&&(O4>=C4)&&(O5<=C5)&&(O6>=C6)&&(O7<=C7)&&(O8>=C8)&&(O9<=C9)&&(O10>=C10)))
      
      {
         if (Display_Zebra11 == true) {   
            ObjectCreate(PatternText[shift], OBJ_TEXT, 0, Time[shift1], Low[shift1] - Range*1.5);
            ObjectSetText(PatternText[shift], "Zebra 11", 9, "Times New Roman", Red);
            upArrow[shift1] = Low[shift1] - Range*0.5;
         }
         if (setalert == 0 && Show_Alert == true) {
            pattern="Zebra 11";
            setalert = 1;
         }
      }
      
      
      if (setalert == 1 && shift == 0) {
         Alert(Symbol(), " ", period, " ", pattern);
         setalert = 0;
      }
   } // End of for loop
     
   
      
   return(0);
}
//+------------------------------------------------------------------+